/*
nova_formo.c

GPC-Haskell - A Haskell port for the GPC library.
Copyright (C) 2005  Marco Tulio Gontijo e Silva

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "nova_formo.h"

#include<stdlib.h>

#include "gpc.h"

int main()
{
  return 0;
}

gpc_nova_vertex gpc_faru_nova_vertex(double x, double y)
{
  gpc_nova_vertex temp;
  temp = (gpc_nova_vertex) malloc(sizeof(*temp));
  temp->x = x;
  temp->y = y;
  return temp;
}

double gpc_x(gpc_nova_vertex a)
{
  return a->x;
}

double gpc_y(gpc_nova_vertex a)
{
  return a->y;
}

gpc_vertex *gpc_nova_vertex_al_vertex(int num_vertices,
                                      gpc_nova_vertex *vertex)
{
  int i;
  gpc_vertex *temp;
  temp = (gpc_vertex*) malloc(sizeof(*temp) * num_vertices);
  for(i = 0; i < num_vertices; i++)
    temp[i] = (gpc_vertex) *(vertex[i]);
  free(vertex);
  return temp;
}

gpc_nova_vertex_list gpc_faru_nova_vertex_list(int num_vertices,
					       gpc_nova_vertex *vertex)
{
  gpc_nova_vertex_list temp;
  temp = (gpc_nova_vertex_list) malloc(sizeof(*temp));
  temp->num_vertices = num_vertices;
  temp->vertex = gpc_nova_vertex_al_vertex(num_vertices, vertex);
  return temp;
}

int gpc_prenu_num_vertices(gpc_nova_vertex_list a)
{
  return a->num_vertices;
}

gpc_nova_vertex *gpc_vertex_al_nova_vertex(int num_vertices,
                                           gpc_vertex *vertex)
{
  int i;
  gpc_nova_vertex *temp;
  temp = (gpc_nova_vertex*) malloc (sizeof(*temp) * num_vertices);
  for(i = 0; i < num_vertices; i++)
    {
      temp[i] = (gpc_nova_vertex) malloc(sizeof(**temp));
      *(temp[i]) = vertex[i];
    }
  free(vertex);
  return temp;
}

gpc_nova_vertex *gpc_prenu_vertex(gpc_nova_vertex_list a)
{
  return gpc_vertex_al_nova_vertex(a->num_vertices, a->vertex);
}

gpc_vertex_list *gpc_nova_vertex_list_al_vertex_list
(int num_contours, gpc_nova_vertex_list *contour)
{
  int i;
  gpc_vertex_list *temp;
  temp = (gpc_vertex_list*) malloc(sizeof(*temp) * num_contours);
  for(i = 0; i < num_contours; i++)
    temp[i] = (gpc_vertex_list) *(contour[i]);
  free(contour);
  return temp;
}

gpc_nova_polygon gpc_faru_nova_polygon(int num_contours, int *hole,
                                       gpc_nova_vertex_list *contour)
{
  gpc_nova_polygon temp;
  temp = (gpc_nova_polygon) malloc(sizeof(*temp));
  temp->num_contours = num_contours;
  temp->hole = hole;
  temp->contour = gpc_nova_vertex_list_al_vertex_list(num_contours, contour);
  return temp;
}

int gpc_prenu_num_contours(gpc_nova_polygon a)
{
  return a->num_contours;
}

int *gpc_prenu_hole(gpc_nova_polygon a)
{
  return a->hole;
}

gpc_nova_vertex_list *gpc_vertex_list_al_nova_vertex_list
(int num_contours, gpc_vertex_list *contour)
{
  int i;
  gpc_nova_vertex_list *temp;
  temp = (gpc_nova_vertex_list*) malloc (sizeof(*temp) * num_contours);
  for(i = 0; i < num_contours; i++)
    {
      temp[i] = (gpc_nova_vertex_list) malloc(sizeof(**temp));
      *(temp[i]) = contour[i];
    }
  free(contour);
  return temp;
}

gpc_nova_vertex_list *gpc_contour(gpc_nova_polygon a)
{
  return gpc_vertex_list_al_nova_vertex_list(a->num_contours, a->contour);
}

gpc_nova_polygon gpc_union(gpc_nova_polygon a, gpc_nova_polygon b)
{
  gpc_nova_polygon temp;
  gpc_polygon_clip(GPC_UNION, (gpc_polygon*) a, (gpc_polygon*) b,
                   (gpc_polygon*) temp);
  return temp;
}

gpc_nova_polygon gpc_diff(gpc_nova_polygon a, gpc_nova_polygon b)
{
  gpc_nova_polygon temp;
  gpc_polygon_clip(GPC_DIFF, (gpc_polygon*) a, (gpc_polygon*) b,
                   (gpc_polygon*) temp);
  return temp;
}

gpc_nova_polygon gpc_int(gpc_nova_polygon a, gpc_nova_polygon b)
{
  gpc_nova_polygon temp;
  gpc_polygon_clip(GPC_INT, (gpc_polygon*) a, (gpc_polygon*) b,
                   (gpc_polygon*) temp);
  return temp;
}

gpc_nova_polygon gpc_xor(gpc_nova_polygon a, gpc_nova_polygon b)
{
  gpc_nova_polygon temp;
  gpc_polygon_clip(GPC_XOR, (gpc_polygon*) a, (gpc_polygon*) b,
                   (gpc_polygon*) temp);
  return temp;
}
