/*
nova_formo.h

GPC-Haskell - A Haskell port for the GPC library.
Copyright (C) 2005  Marco Tulio Gontijo e Silva

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "gpc.h"

typedef gpc_vertex *gpc_nova_vertex;

typedef gpc_vertex_list *gpc_nova_vertex_list;

typedef gpc_polygon *gpc_nova_polygon;

gpc_nova_vertex gpc_faru_nova_vertex(double x, double y);

double gpc_prenu_x(gpc_nova_vertex a);

double gpc_prenu_y(gpc_nova_vertex a);

gpc_nova_vertex_list gpc_faru_nova_vertex_list(int num_vertices,
					       gpc_nova_vertex *vertex);

int gpc_prenu_num_vertices(gpc_nova_vertex_list a);

gpc_nova_vertex *gpc_prenu_vertex(gpc_nova_vertex_list a);

gpc_nova_polygon gpc_faru_nova_polygon(int num_contours, int *hole,
                                       gpc_nova_vertex_list *contour);

int gpc_prenu_num_contours(gpc_nova_polygon a);

int *gpc_prenu_hole(gpc_nova_polygon a);

gpc_nova_vertex_list *gpc_prenu_contour(gpc_nova_polygon a);

gpc_nova_polygon gpc_union(gpc_nova_polygon a, gpc_nova_polygon b);

gpc_nova_polygon gpc_diff(gpc_nova_polygon a, gpc_nova_polygon b);

gpc_nova_polygon gpc_int(gpc_nova_polygon a, gpc_nova_polygon b);

gpc_nova_polygon gpc_xor(gpc_nova_polygon a, gpc_nova_polygon b);
