-- Tests.hs

-- HGPC: A Haskell port for GPC.
-- This file is part of HGPC.
-- Copyright (C) 2007 Marco Túlio Gontijo e Silva

-- HGPC is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.

-- HGPC is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with HGPC; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

module Main (main) where

import Data.List hiding (union)
import Data.Set hiding (difference, intersection, union, map)
import Control.Exception

import Algebra.Geometric.Gpc

main :: IO ()
main =
    evaluate (
        map (\operation -> polygon1 `operation` polygon2)
        [difference, intersection, xor, union])
    >> return ()

polygon1 :: Polygon
polygon1 =
    PolygonC $ fromList $ [
        (False, ContourC [VertexC 0 0, VertexC 0 1, VertexC 2 1, VertexC 2 0])]

polygon2 :: Polygon
polygon2 =
    PolygonC $ fromList $ [
        (False, ContourC [VertexC 1 0, VertexC 1 1, VertexC 3 1, VertexC 3 0])]
