Imports System
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Windows.Forms
Imports wraptest.GpcWrapper

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Dim fontFamily As fontFamily = New fontFamily("Times New Roman")
    Dim flatness As Single = 1.0F

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        Size = New Size(850, 550)
        Text = "GpcTest"
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container
        Me.Text = "Form1"
    End Sub
#End Region

    Protected Overrides Sub OnPaint(ByVal e As PaintEventArgs)
        Dim p As GraphicsPath = New GraphicsPath

        ' draw A
        p.AddString("A", fontFamily, 0, 250, New Point(0, 0), New StringFormat)
        p.Flatten(New Matrix, flatness)
        e.Graphics.FillPath(Brushes.DarkGray, p)
        e.Graphics.DrawPath(New Pen(Color.Black, 2.0F), p)
        ' draw B
        p.AddString("B", fontFamily, 0, 250, New Point(0, 250), New StringFormat)
        p.Flatten(New Matrix, flatness)
        e.Graphics.FillPath(Brushes.DarkGray, p)
        e.Graphics.DrawPath(New Pen(Color.Black, 2.0F), p)

        ' create polygonA
        p = New GraphicsPath
        p.AddString("A", fontFamily, 0, 250, New Point(0, 0), New StringFormat)
        p.Flatten(New Matrix, flatness)
        Dim polygonA As Polygon = New Polygon(p)

        ' create polygonB
        p = New GraphicsPath
        p.AddString("B", fontFamily, 0, 250, New Point(0, 0), New StringFormat)
        p.Flatten(New Matrix, flatness)
        Dim polygonB As Polygon = New Polygon(p)

        ' Save and Load
        polygonA.Save("A.plg", True)
        Dim loadedPolygon As Polygon = polygon.FromFile("A.plg", True)

        ' create Tristrip
        Dim tristrip As Tristrip = polygonA.ToTristrip()
        Dim i As Integer
        For i = 0 To tristrip.NofStrips - 1 Step i + 1
            Dim vertexList As VertexList = tristrip.Strip(i)
            Dim path As GraphicsPath = vertexList.TristripToGraphicsPath()
            Dim m As Matrix = New Matrix
            m.Translate(600, 0)
            path.Transform(m)
            e.Graphics.FillPath(Brushes.DarkGray, path)
            e.Graphics.DrawPath(Pens.Black, path)
        Next

        Dim upperLeftCorner() As PointF = New PointF() {New PointF(200, 0), New PointF(200, 250), New PointF(400, 0), New PointF(400, 250)}

        Dim position As Integer = 0
        Dim operation As GpcOperation
        For Each operation In System.Enum.GetValues(GetType(GpcOperation))
            Dim polygon As Polygon = polygonA.Clip(operation, polygonB)
            Dim path As GraphicsPath = polygon.ToGraphicsPath()
            Dim m As Matrix = New Matrix
            m.Translate(upperLeftCorner(position).X, upperLeftCorner(position).Y)
            path.Transform(m)
            e.Graphics.FillPath(Brushes.DarkGray, path)
            e.Graphics.DrawPath(Pens.Black, path)
            position = position + 1
        Next
    End Sub

End Class
